import urllib
import urlparse
import httplib

import os

import base64
import urllib

from OFS.Folder import Folder
from OFS.DTMLDocument import DTMLDocument

from Products.PythonScripts.PythonScript import PythonScript

import lasso
lasso.init()

from zLOG import LOG, INFO

def set_liberty_urls(id, myroot):
    if myroot.hasObject('liberty') is True:
        myroot._delObject('liberty')

    liberty_ob = Folder('liberty')
    myroot._setObject('liberty', liberty_ob)

    #zhome=os.environ['ZOPE_HOME']
    #zope_home = globals()['__builtins__']['ZOPE_HOME']
    instance_home = os.environ.get('INSTANCE_HOME')
    liberty_scripts_home = instance_home + '/Products/LibertyAuthPlugin/scripts/'

    dtml_home = instance_home + '/Products/LibertyAuthPlugin/dtml/'

    # choose local login or token registration :
    fd = open(dtml_home + 'chooseFederationMethod.dtml')
    content = fd.read()
    fd.close()
    dtml_ob = DTMLDocument(content, __name__ = 'chooseFederationMethod')
    liberty_ob._setObject('chooseFederationMethod', dtml_ob)

    # register user token :
    fd = open(dtml_home + 'registerUserToken.dtml')
    content = fd.read()
    fd.close()
    dtml_ob = DTMLDocument(content, __name__ = 'registerUserToken')
    liberty_ob._setObject('registerUserToken', dtml_ob)

    # complete user token registration :
    fd = open(liberty_scripts_home + 'completeUserTokenRegistration.py')
    content = fd.read()
    content = content % {'libplugin_id' : id}
    fd.close()
    script_ob = PythonScript('completeUserTokenRegistration')
    script_ob.write(content)
    liberty_ob._setObject('completeUserTokenRegistration', script_ob)



    # register new federated account :
    fd = open(dtml_home + 'registerFederatedAccount.dtml')
    content = fd.read()
    fd.close()
    dtml_ob = DTMLDocument(content, __name__ = 'registerFederatedAccount')
    liberty_ob._setObject('registerFederatedAccount', dtml_ob)

    # complete user token registration :
    fd = open(liberty_scripts_home + 'completeUserFederatedAccount.py')
    content = fd.read()
    content = content % {'libplugin_id' : id}
    fd.close()
    script_ob = PythonScript('completeUserFederatedAccount')
    script_ob.write(content)
    liberty_ob._setObject('completeUserFederatedAccount', script_ob)



    # signOn :
    fd = open(liberty_scripts_home + 'signOn.py')
    content = fd.read()
    content = content % {'libplugin_id' : id}
    fd.close()
    script_ob = PythonScript('signOn')
    script_ob.write(content)
    liberty_ob._setObject('signOn', script_ob)

    # assertionConsumerService :
    fd = open(liberty_scripts_home + 'assertionConsumerService.py')
    content = fd.read()
    content = content % {'libplugin_id' : id}
    fd.close()
    script_ob = PythonScript('assertionConsumerService')
    script_ob.write(content)
    liberty_ob._setObject('assertionConsumerService', script_ob)

    # completeAssertionConsumer :
    fd = open(liberty_scripts_home + 'completeAssertionConsumerService.py')
    content = fd.read()
    content = content % {'libplugin_id' : id}
    fd.close()
    script_ob = PythonScript('completeAssertionConsumerService')
    script_ob.write(content)
    liberty_ob._setObject('completeAssertionConsumerService', script_ob)

    # singleLogout :
    fd = open(liberty_scripts_home + 'singleLogout.py')
    content = fd.read()
    content = content % {'libplugin_id' : id}
    fd.close()
    script_ob = PythonScript('singleLogout')
    script_ob.write(content)
    liberty_ob._setObject('singleLogout', script_ob)

    # singleLogoutReturn :
    fd = open(liberty_scripts_home + 'singleLogoutReturn.py')
    content = fd.read()
    content = content % {'libplugin_id' : id}
    fd.close()
    script_ob = PythonScript('singleLogoutReturn')
    script_ob.write(content)
    liberty_ob._setObject('singleLogoutReturn', script_ob)

    # federationTermination :
    fd = open(liberty_scripts_home + 'federationTermination.py')
    content = fd.read()
    content = content % {'libplugin_id' : id}
    fd.close()
    script_ob = PythonScript('federationTermination')
    script_ob.write(content)
    liberty_ob._setObject('federationTermination', script_ob)

    # soapEndpoint :
    fd = open(liberty_scripts_home + 'soapEndpoint.py')
    content = fd.read()
    content = content % {'libplugin_id' : id}
    fd.close()
    script_ob = PythonScript('soapEndpoint')
    script_ob.write(content)
    liberty_ob._setObject('soapEndpoint', script_ob)

def set_provider_metadata(metadata_filepath, role, root_provider, organism_name):
    provider_id = root_provider + 'metadata'
    content_metadata = """<?xml version="1.0"?>
<EntityDescriptor
    providerID="%s"
    xmlns="urn:liberty:metadata:2003-08">""" % provider_id
    federation_termination_service_url = root_provider + 'federationTermination'
    single_logout_service_url = root_provider + 'singleLogout'
    single_logout_service_return_url = root_provider + 'singleLogoutReturn'
    soap_endpoint = root_provider + 'soapEndpoint'
    if role == 'sp':
        assertion_consumer_service_url = root_provider + 'assertionConsumerService'
        content_metadata += """
  <SPDescriptor protocolSupportEnumeration="urn:liberty:iff:2003-08">
    <SoapEndpoint>%s</SoapEndpoint>

    <SingleLogoutServiceURL>%s</SingleLogoutServiceURL>
    <SingleLogoutServiceReturnURL>%s</SingleLogoutServiceReturnURL>

    <AssertionConsumerServiceURL id="AssertionConsumerService1" isDefault="true">%s</AssertionConsumerServiceURL>

    <FederationTerminationServiceURL>%s</FederationTerminationServiceURL>
    <FederationTerminationNotificationProtocolProfile>http://projectliberty.org/profiles/fedterm-idp-soap</FederationTerminationNotificationProtocolProfile>
    <FederationTerminationNotificationProtocolProfile>http://projectliberty.org/profiles/fedterm-idp-http</FederationTerminationNotificationProtocolProfile>
    <FederationTerminationNotificationProtocolProfile>http://projectliberty.org/profiles/fedterm-sp-soap</FederationTerminationNotificationProtocolProfile>

    <SingleLogoutProtocolProfile>http://projectliberty.org/profiles/slo-idp-soap</SingleLogoutProtocolProfile>
    <SingleLogoutProtocolProfile>http://projectliberty.org/profiles/slo-idp-http</SingleLogoutProtocolProfile>
    <SingleLogoutProtocolProfile>http://projectliberty.org/profiles/slo-sp-http</SingleLogoutProtocolProfile>

    <AuthnRequestsSigned>true</AuthnRequestsSigned>
  </SPDescriptor>
""" % (soap_endpoint,
       single_logout_service_url,
       single_logout_service_return_url,
       assertion_consumer_service_url,
       federation_termination_service_url)
    content_metadata += """
  <Organization>
    <OrganizationName>%s</OrganizationName>
  </Organization>
</EntityDescriptor>
""" % organism_name

    fd = open(metadata_filepath, 'w')
    fd.write(content_metadata)
    fd.close()

def set_provider_keys(privatekey_path, publickey_path):
    # FIXME: use a poper way to generrate private and public key files :
    os.system('openssl genrsa -out %s 2048' % (privatekey_path))
    os.system('openssl rsa -in %s -pubout -out %s' % (privatekey_path, publickey_path))

class Liberty:
    def __init__(self, metadata, privatekey, publickey):
        self._metadata = metadata
        self._privatekey = privatekey
        self._publickey = publickey
        
        self._userIdByNameIdentifier = {}
        self._identityDumpByNameIdentifier = {}

    def assertionConsumerService(self, context, user):
        # FIXME: Implement LARES form method.
        lares = None
        request = context.REQUEST
        session = request.SESSION
        query_string = urllib.unquote(request.get('QUERY_STRING'))
        userId = user.getId()

        lassoServer = self.getLassoServer()
        login = lasso.Login(lassoServer)
        if query_string:
            login.initRequest(query_string, lasso.HTTP_METHOD_REDIRECT)
            login.buildRequestMsg()
            soapResponseMessage = self.sendSoapRequest(login.msgUrl, login.msgBody)
            login.processResponseMsg(soapResponseMessage)
        elif lares:
            login.processAuthnResponse(lares)
        else:
            # FIXME: Proper process of missing one of the response method (raise ?).
            LOG('LibertyAuthPlugin', INFO, 'Missing liberty SSO in IDP HTTP response.')
        login.acceptSso()
        nameIdentifier = None
        if login.nameIdentifier:
            nameIdentifier = login.nameIdentifier.content
        identityDump = None
        if login.identity:
            identityDump = login.identity.dump()
        if login.session:
            sessionDump = login.session.dump()

        session['nameIdentifier'] = nameIdentifier
        session['sessionDump'] = sessionDump

        next_url = None
        libertyRegisteredUserId = self.getUserId(nameIdentifier)
        if libertyRegisteredUserId:
            LOG('', INFO, 'user already federated : ' + libertyRegisteredUserId)
            next_url = context.absolute_url()
        elif userId and userId == libertyRegisteredUserId:
            self.setUserId(nameIdentifier, userId)
            self.setIdentityDump(nameIdentifier, identityDump)
            LOG('', INFO, 'user just federated now : ' + libertyRegisteredUserId)
            next_url = context.absolute_url()
        else:
            LOG('', INFO, 'user not federated')
            session['identityDump'] = identityDump
            next_url = context.portal_url() + '/liberty/chooseFederationMethod'

        LOG('', INFO, 'query string : ' + query_string)
        if query_string:
            tuples = {}
            splitted = query_string.strip('/').split('&')
            for c in splitted:
                key, value = c.split('=', 1)
                tuples[key] = value
            relayState = tuples.get('RelayState')
            if relayState:
                session['identityDump'] = identityDump
                next_url = base64.decodestring(relayState)

        return next_url

    def completeAssertionConsumerService(self, context, user):
        request = context.REQUEST
        session = request.SESSION

        userId = user.getId()
        if userId is None:
            userId = session.get('userId')
            self.removeUserToken(userId)

        nameIdentifier = session['nameIdentifier']
        sessionDump = session['sessionDump']
        identityDump = session['identityDump']
        if identityDump:
            del session['identityDump']

        LOG('', INFO, 'name identifier : ' + nameIdentifier + ' user id : ' + userId)
        self.setUserId(nameIdentifier, userId)
        self.setIdentityDump(nameIdentifier, identityDump)
        # FIXME: If a relay state, returns to it instead.
        return context.absolute_url()

    def completeUserRegisteredFederation(self, context):
        request = context.REQUEST
        session = request.SESSION
        acl_users = context.acl_users

        userId = request.form['userId']
        # FIXME: Not sure it is the right method to use (a method like addUser() must exist ... ).
        acl_users._doAddUser(userId, userId, [], [])
        session['userId'] = userId
        return context.portal_url() + '/liberty/completeAssertionConsumerService'

    def completeUserTokenRegistration(self, context):
        request = context.REQUEST
        session = request.SESSION

        userToken = request.form.get('userToken')
        if userToken is None:
            query_string = request.QUERY_STRING
            splitted = query_string.strip('/').split('&')
            tuples = {}
            for c in splitted:
                key, value = c.split('=')
                tuples[key] = value
            userToken = tuples['userToken']

        userId = self.getUserIdByUserToken(userToken)
        session['userId'] = userId
        self.removeUserToken(userToken)

        return context.portal_url() + '/liberty/completeAssertionConsumerService'

    def federationTermination(self, context):
        request = context.REQUEST
        session = request.SESSION

        sessionDump = session.get('sessionDump')
        nameIdentifier = session.get('nameIdentifier')
        identityDump = self.getIdentityDump(nameIdentifier)

        query_string = request.get('QUERY_STRING') or ''
        if lasso.isLibertyQuery(query_string):
            next_url, body = self.processFederationTerminationNotificationMsg(fedTermRequest, sessionDump, identityDump)
            if sessionDump:
                del session['sessionDump']
            if nameIdentifier:
                del session['nameIdentifier']
            context.acl_users.logout(request)
            return next_url
        else:
            lassoServer = self.getLassoServer()
            fedTerm = lasso.Defederation(lassoServer)
            fedTerm.setSessionFromDump(sessionDump)
            fedTerm.setIdentityFromDump(identityDump)
            fedTerm.initNotification(lassoServer.providerIds[0], lasso.HTTP_METHOD_SOAP)
            fedTerm.buildNotificationMsg()
            soapResponseMessage = self.sendSoapRequest(fedTerm.msgUrl, fedTerm.msgBody)
            self.removeUserId(nameIdentifier)
            self.removeIdentityDump(nameIdentifier)
            del session['nameIdentifier']
            del session['sessionDump']
            return context.absolute_url()

    def getIdentityDump(self, nameIdentifier):
        return self._identityDumpByNameIdentifier.get(nameIdentifier)

    def getLassoServer(self):
        instance_home = os.environ.get('INSTANCE_HOME')
        plugin_home = instance_home + '/Products/LibertyAuthPlugin'
        provider_home = plugin_home + '/liberty/' + self.id.replace(' ', '_')

        metadata = provider_home + '/metadata.xml'
        lassoServer = lasso.Server(metadata, self._privatekey, None, None)

        providers_home = provider_home + '/providers'
        providers_filenames = []
        try:
            providers_filenames = os.listdir(providers_home)
        except:
            LOG('', INFO, 'Liberty.py - listing provider dirs ...')

        for name in providers_filenames:
            metadata = providers_home + '/' + name + '/metadata.xml'
            publickey = providers_home + '/' + name + '/publickey.pem'
            role = name.split('-')[1]
            if role == 'sp':
                lassoServer.addProvider(lasso.PROVIDER_ROLE_SP, metadata, publickey, None)
            else:
                lassoServer.addProvider(lasso.PROVIDER_ROLE_IDP, metadata, publickey, None)
        return lassoServer

    def getNameIdentifier(self, userId):
        for n in self._userIdByNameIdentifier:
            u = self._userIdByNameIdentifier[n]
            if u == userId:
                return n
        return None

    def getUserId(self, nameIdentifier):
        return self._userIdByNameIdentifier.get(nameIdentifier)

    def processLogoutRequestMsg(self, logoutRequestMessage, sessionDump, identityDump):
        logout = lasso.Logout(self.getLassoServer())
        logout.processRequestMsg(logoutRequestMessage)
        logout.setSessionFromDump(sessionDump)
        logout.setIdentityFromDump(identityDump)
        try:
            logout.validateRequest()
        except lasso.Error, error:
            if error[0] != lasso.PROFILE_ERROR_SESSION_NOT_FOUND:
                raise
        logout.buildResponseMsg()
        return logout.msgUrl, logout.msgBody

    def processFederationTerminationNotificationMsg(self, fedTermRequestMessage, sessionDump, identityDump):
        defederation = lasso.Defederation(self.getLassoServer())
        defederation.processNotificationMsg(fedTermRequestMessage)
        defederation.setSessionFromDump(sessionDump)
        defederation.setIdentityFromDump(identityDump)
        try:
            defederation.validateNotification()
        except lasso.Error, error:
            pass # ignore failure (?)
        return defederation.msgUrl, defederation.msgBody

    def removeIdentityDump(self, nameIdentifier):
        del self._identityDumpByNameIdentifier[nameIdentifier]
        new_identity_dumps = {}
        for key in self._identityDumpByNameIdentifier.keys():
            new_identity_dumps[key] = self._identityDumpByNameIdentifier[key]
        self._identityDumpByNameIdentifier = new_identity_dumps

    def removeUserId(self, nameIdentifier):
        del self._userIdByNameIdentifier[nameIdentifier]
        new_user_name_identifiers = {}
        for key in self._userIdByNameIdentifier.keys():
            new_user_name_identifiers[key] = self._userIdByNameIdentifier[key]
        self._userIdByNameIdentifier = new_user_name_identifiers

    def sendSoapRequest(self, url, soapRequestMessage):
        if url.startswith('http://'):
            host, query = urllib.splithost(url[5:])
            conn = httplib.HTTPConnection(host)
        else:
            host, query = urllib.splithost(url[6:])
            conn = httplib.HTTPSConnection(host)
        conn.request("POST", query, soapRequestMessage, {'Content-Type': 'text/xml'})
        response = conn.getresponse()
        soapResponseMessage = response.read()
        conn.close()
        if response.status not in (200, 204):
            print 'Invalid SOAP response'
            return None
        return soapResponseMessage

    def setIdentityDump(self, nameIdentifier, identityDump):
        new_identityDumpByNameIdentifier = {}
        for n in self._identityDumpByNameIdentifier.keys():
            new_identityDumpByNameIdentifier[n] = self._identityDumpByNameIdentifier[n]
        new_identityDumpByNameIdentifier[nameIdentifier] = identityDump
        self._identityDumpByNameIdentifier = new_identityDumpByNameIdentifier

    def setUserId(self, nameIdentifier, userId):
        new_userIdByNameIdentifier = {}
        for n in self._userIdByNameIdentifier.keys():
            if self._userIdByNameIdentifier[n] == userId:
                continue
            new_userIdByNameIdentifier[n] = self._userIdByNameIdentifier[n]
        new_userIdByNameIdentifier[nameIdentifier] = userId
        self._userIdByNameIdentifier = new_userIdByNameIdentifier

    def signOn(self, context):
        lassoServer = self.getLassoServer()
        login = lasso.Login(lassoServer)
        login.initAuthnRequest(lassoServer.providerIds[0], lasso.HTTP_METHOD_REDIRECT)
        login.request.nameIdPolicy = "federated"
        login.request.forceAuthn = False
        login.request.isPassive = False
        login.request.consent = "urn:liberty:consent:obtained"

        # if RelayState, then give it to Lasso
        query_string = context.REQUEST.QUERY_STRING
        if query_string:
            splitted = query_string.strip('/').split('&')
            tuples = {}
            for c in splitted:
                key, value = c.split('=', 1)
                tuples[key] = value
            relayState = tuples.get('RelayState')
            if relayState:
                login.request.relayState = relayState

        login.buildAuthnRequestMsg()
        LOG('', INFO, 'sso : ' + login.msgUrl)
        return login.msgUrl

    def singleLogoutSOAP(self, context):
        request = context.REQUEST
        response = request.RESPONSE
        session = request.SESSION

        sessionDump = session.get('sessionDump')
        nameIdentifier = session.get('nameIdentifier')
        identityDump = self.getIdentityDump(nameIdentifier)

        query_string = request.get('QUERY_STRING') or ''
        if lasso.isLibertyQuery(query_string):
            next_url, body = self.processLogoutRequestMsg(query_string, sessionDump, identityDump)
            if sessionDump:
                del session['sessionDump']
            if nameIdentifier:
                del session['nameIdentifier']
            context.acl_users.logout(request)
            return next_url
        else:
            lassoServer = self.getLassoServer()
            logout = lasso.Logout(lassoServer)
            logout.setSessionFromDump(sessionDump)
            logout.setIdentityFromDump(identityDump)
            logout.initRequest(None, lasso.HTTP_METHOD_SOAP)
            logout.buildRequestMsg()
            soapResponseMessage = self.sendSoapRequest(logout.msgUrl, logout.msgBody)
            logout.processResponseMsg(soapResponseMessage)
            del session['sessionDump']
            del session['nameIdentifier']
            context.acl_users.logout(request)
            return context.absolute_url()

    def singleLogout(self, context):
        request = context.REQUEST
        response = request.RESPONSE
        session = request.SESSION

        sessionDump = session.get('sessionDump')
        nameIdentifier = session.get('nameIdentifier')
        identityDump = self.getIdentityDump(nameIdentifier)

        query_string = request.get('QUERY_STRING') or ''
        if lasso.isLibertyQuery(query_string):
            next_url, body = self.processLogoutRequestMsg(query_string, sessionDump, identityDump)
            if sessionDump:
                del session['sessionDump']
            if nameIdentifier:
                del session['nameIdentifier']
            context.acl_users.logout(request)
            return next_url
        else:
            lassoServer = self.getLassoServer()
            logout = lasso.Logout(lassoServer)
            logout.setSessionFromDump(sessionDump)
            logout.setIdentityFromDump(identityDump)
            logout.initRequest(None, lasso.HTTP_METHOD_REDIRECT)
            logout.buildRequestMsg()
            return logout.msgUrl

    def singleLogoutReturn(self, context):
        request = context.REQUEST
        response = request.RESPONSE
        session = request.SESSION

        sessionDump = session.get('sessionDump')
        nameIdentifier = session.get('nameIdentifier')
        identityDump = self.getIdentityDump(nameIdentifier)

        query_string = request.get('QUERY_STRING') or ''
        lassoServer = self.getLassoServer()
        logout = lasso.Logout(lassoServer)
        logout.setSessionFromDump(sessionDump)
        logout.setIdentityFromDump(identityDump)
        try:
            logout.processResponseMsg(query_string)
        except lasso.Error, error:
            if error[0] != lasso.PROFILE_ERROR_SESSION_NOT_FOUND:
                raise
        else:
            del session['sessionDump']
            del session['nameIdentifier']
            context.acl_users.logout(request)
        return context.absolute_url()

    def getSessionFromNameIdentifier(self, session_data, nameIdentifier):
        for session in session_data.items():
            contents = session[1]
            content_keys = contents.keys()
            ni = contents.get('nameIdentifier')
            if ni and ni == nameIdentifier:
                return session
        return None

    def removeLibertyDataFromSession(self, session):
        contents = session[1]
        del contents['sessionDump']
        del contents['nameIdentifier']

    def soapEndpoint(self, session_data, soapRequestMessage):
        status = '404'
        soapResponseMessage = None

        request_type = lasso.getRequestTypeFromSoapMsg(soapRequestMessage)

        if request_type == lasso.REQUEST_TYPE_LOGOUT:
            logout = lasso.Logout(self.getLassoServer())
            logout.processRequestMsg(soapRequestMessage)
            nameIdentifier = logout.nameIdentifier.content
            identityDump = self.getIdentityDump(nameIdentifier)
            logout.setIdentityFromDump(identityDump)
            sessionDump = self.getSessionDumpFromSessionData(session_data)
            logout.setSessionFromDump(sessionDump)
            try:
                logout.validateRequest()
            except lasso.Error, error:
                if error[0] != lasso.PROFILE_ERROR_SESSION_NOT_FOUND:
                    raise
            else:
                the_session = self.getSessionFromNameIdentifier(session_data, nameIdentifier)
                if the_session:
                    self.removeLibertyDataFromSession(session_data, nameIdentifier)
                    the_session.invalidate()
            logout.buildResponseMsg()
            return logout.msgBody

        elif request_type == lasso.REQUEST_TYPE_DEFEDERATION:
            defederation = lasso.Defederation(self.getLassoServer())
            defederation.processNotificationMsg(soapRequestMessage)
            nameIdentifier = defederation.nameIdentifier.content
            identityDump = self.getIdentityDump(nameIdentifier)
            defederation.setIdentityFromDump(identityDump)
            try:
                defederation.validateNotification()
            except lasso.Error, error:
                pass
            else:
                self.removeIdentityDump(nameIdentifier)
                the_session = self.getSessionFromNameIdentifier(session_data, nameIdentifier)
                if the_session:
                    self.removeLibertyDataFromSession(the_session)
            status = '204'
 
        return status, soapResponseMessage
