#
# $Id: __init__.py,v 1.2 2006/05/09 07:12:29 fpeters Exp $
#
# Copyright (c) 2003-2005 Dirk Datzert
# All rights reserved. Written by Dirk Datzert <dirk@datzert.de>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products
#    derived from this software without specific prior written permission
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

from App.version_txt import getZopeVersion


if ( getZopeVersion()[0:3] == (-1,-1,-1) or
     getZopeVersion()[0:3] == (2,6,4) or
     getZopeVersion()[0:2] == (2,7) or
     getZopeVersion()[0:2] == (2,8)):

    import HTTPRequest

    from Products.PythonScripts.Utility import allow_module, allow_class 

    allow_module('base64')

    allow_module('SOAPpy')
    allow_module('SOAPpy.Types')


try:

    from WSDLObject import WSDLObject, \
        manage_addWSDLObjectForm, manage_addWSDLObject, \
        ADD_WSDL_OBJECT_PERMISSION
    
    def initialize(context):

        context.registerClass(
            WSDLObject,
            permission   = ADD_WSDL_OBJECT_PERMISSION,
            constructors = ( manage_addWSDLObjectForm, manage_addWSDLObject ),
            icon='icons/wsdlobject.gif',
            meta_type = WSDLObject.meta_type
            )

        context.registerBaseClass(WSDLObject)

        try:
            from Products.ZBabel import ZBabelTag
        except:
            import NoBabelTag


except:
    
    import traceback
    traceback.print_exc()

#    vim:ts=4
